<?php $inc_microtime = inc_microtime();

$inc_version	= '1.0.0';
$inc_copyright	= '2007, IncPlugins';
$inc_website	= 'http://www.incplugins.com/';
$inc_license	= 'http://www.incplugins.com/inc/license.php';

// PHP 4.1.0 or later is required

if (!defined('INC'))
{
	if (isset($HTTP_GET_VARS['inc']))
		define('INC', strtr($HTTP_GET_VARS['inc'], ':/\\', '___'));
	else
		define('INC', 'settings');
}

$ob_on = true;
$inc_plugins = array();
// Directories
$script_dir = dirname(realpath($_SERVER['SCRIPT_FILENAME']));
$inc_dir = dirname(realpath(__FILE__));
$inc_file = basename(__FILE__, '.php');
$root_dir = dirname($inc_dir);
$root = inc_rel_url($script_dir, $root_dir);
$homepage = $root;
if ($homepage == '')
{
	if (str_replace('\\', '/', dirname($_SERVER['PHP_SELF'])) == '/')
		$homepage = '/';
	else
		$homepage = './';
}
$inc = inc_rel_url($script_dir, $inc_dir);
$root_dir = str_replace('\\', '/', $root_dir).'/';
$script_dir = str_replace('\\', '/', $script_dir).'/';
$inc_dir = str_replace('\\', '/', $inc_dir).'/';
// Multilang
$lang = 'en';
$T = array();
// HTML frame
$html_on = true;
$doctype = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"'
	."\n".'"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
//$doctype = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"'
//	."\n".'"http://www.w3.org/TR/html4/loose.dtd">';
$xml_header = true;
$charset = '';
$html_lang = 'en';
$title_prefix = '';
$title = '';
$title_suffix = '';
$base_href = '';
$custom_head_tags1 = '';
$description = '';
$keywords = '';
$robots = '';
$refresh = '';
$custom_meta_tags = '';
$custom_head_tags2 = '';
$body_attributes = '';
$footer = '</body></html>';
// External files
$js_file = '';
$css_file = '';
// Expires
$expires = 0;
$js_expires = 3600; // hour
$css_expires = 3600; // hour
// Gzip
$gzip = -1; // 0, -1, 1..9(best)
$js_gzip = -1; // 0, -1, 1..9(best)
$css_gzip = -1; // 0, -1, 1..9(best)
// Settings,including and reloading
$inc_included = false;
$inc_page = false;
$inc_break = false;
foreach(explode(',',INC) as $i)
{
	@include_once $inc_dir.$i.'.php';
	if ($inc_break)
        break;
}
inc_header();
if($inc_page)
{
	include_once $inc_page;
	exit;
}

function inc_plugin($name)
{
	global $inc_plugins;
	array_push($inc_plugins, $name);
	$GLOBALS[$name.'_on'] = true;
}

function inc_disable_plugins()
{
	global $inc_plugins;
	foreach($inc_plugins as $item)
	{
		$GLOBALS[$item.'_on'] = false;
	}
}

function inc_microtime()
{
	list($usec, $sec) = explode(' ', microtime());
	return ((float)$usec + (float)$sec);
}

function T($text, $language='')
{
	global $html_lang;
	if (strlen($language) == 0)
	{
		if ($html_lang)
			$l = $html_lang;
		else
			$l = $GLOBALS['lang'];
	}
	else
		$l = $language;
	$r = $GLOBALS['T'][$l][$text];
	if (strlen($r) == 0)
		$r = $text;
	return $r;
}

function is_index()
{
	return (strpos($_SERVER['SCRIPT_NAME'], '/index.') !== false);
}

function is_homepage()
{
	global $root_dir, $script_dir;
	return (($root_dir == $script_dir) and is_index());
}

function inc_expires($seconds)
{
	header('Cache-Control: must-revalidate');
	header('Expires: '.gmdate('D, d M Y H:i:s',time()+$seconds).' GMT');
}

function inc_gzip($level)
{
	ini_set('zlib.output_compression_level', $level);
	if (extension_loaded('zlib') && ini_get('zlib.output_compression') == 0
		&& ini_get('output_handler') != 'ob_gzhandler')
		ob_start('ob_gzhandler');
}

function inc_header()
{
	global $inc_plugins, $HTTP_GET_VARS, $homepage, $inc_dir,
		$js_file, $css_file, $css_expires, $js_expires, $css_gzip, $js_gzip;
	// Direct check
	if (realpath($_SERVER['SCRIPT_FILENAME']) != realpath(__FILE__))
		return;
	// CSS check
	if ($HTTP_GET_VARS['as'] == 'css')
	{
		header('Content-Type: text/css');
		if ($css_expires)
			inc_expires($css_expires);
		if ($css_gzip !== 0)
			inc_gzip($css_gzip);
		if ($css_file)
			@include $inc_dir.$css_file;
		foreach($inc_plugins as $item)
		{
			$func = $item.'_css';
			if (function_exists($func))
			{
				echo '/'.'* '.$item.' *'.'/'."\n";
				$func();
			}
		}
		exit;
	}
	// JS check
	if ($HTTP_GET_VARS['as'] == 'js')
	{
		header('Content-Type: Content-Type: application/x-javascript');
		if ($js_expires)
			inc_expires($js_expires);
		if ($js_gzip !== 0)
			inc_gzip($js_gzip);
		if ($js_file)
			@include $inc_dir.$js_file;
		foreach($inc_plugins as $item)
		{
			$func = $item.'_js';
			if (function_exists($func))
			{
				echo '/'.'* '.$item.' *'.'/'."\n";
				$func();
			}
		}
		exit;
	}
	// Error
	if (isset($HTTP_GET_VARS['http_error']))
	{
		foreach($inc_plugins as $item)
		{
			$func = $item.'_error';
			if (function_exists($func))
				$func((int)$HTTP_GET_VARS['http_error']);
		}
	}
	header('Location: '.$homepage);
	exit;
}

function inc_rel_url($p1, $p2)
{
	$a1 = explode('/', str_replace('\\', '/', $p1));
	$a2 = explode('/', str_replace('\\', '/', $p2));
	$s1 = count($a1);
	$s2 = count($a2);
	$r = '';
	for ($i=0; $i<min($s1, $s2); $i++)
	{
		if ($a1[$i] == $a2[$i])
			continue;
		else
			$r = '../'.$r.$a2[$i].'/';
	}
	if ($s1 > $s2)
		for ($i=$s2; $i<$s1; $i++)
			$r = '../'.$r;
	else if ($s2 > $s1)
		for ($i=$s1; $i<$s2; $i++)
			$r .= $a2[$i].'/';
		return $r;
}

function inc_text()
{
	global $html_on, $doctype, $charset,
		$base_href, $custom_head_tags, $description, $keywords, $robots,
		$refresh, $inc_plugins, $inc, $inc_file, $css_file, $js_file, $custom_meta_tags,
		$custom_head_tags2, $body_attributes, $html_lang, $xml_header;
	$p = '';
	foreach($inc_plugins as $item)
	{
		if ($GLOBALS[$item.'_on'] === true)
		{
			$func = $item.'_head';
			if (function_exists($func))
				$p.= $func();
		}
	}
	$r = '';
	if ($html_on === true)
	{
		if (strpos($doctype, 'XHTML') !== false)
		{
			if ($xml_header)
			{
				$isIE = ((strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false)
					and (strpos($_SERVER['HTTP_USER_AGENT'], 'Opera') === false));
				if ($charset and (strtolower($charset) !== 'utf-8') and !$isIE) // Quirks mode bug in IE
					$r.= '<'.'?xml version="1.0" encoding="'.$charset.'"?'.">\n";
			}
			$r.= $doctype."\n".'<html xmlns="http://www.w3.org/1999/xhtml"';
			if ($html_lang)
				$r.= ' xml:lang="'.$html_lang.'" lang="'.$html_lang.'"';
			$r.= '><head>'."\n";
		}
		else
		{
			$r.= $doctype."\n";
			if ($html_lang)
				$r.= '<html lang="'.$html_lang.'"><head>'."\n";
			else
				$r.= "<html><head>\n";
		}
		if ($charset)
			$r.= '<meta http-equiv="Content-Type" content="text/html; charset='.$charset.'"'." />\n";
		$r.= '<title>'.$GLOBALS['title_prefix'].$GLOBALS['title'].$GLOBALS['title_suffix']."</title>\n";
		if ($base_href)
			$r.= '<base href="'.$base_href.'"'." />\n";
		if ($custom_head_tags)
			$r.= $custom_head_tags."\n";
		if ($description)
			$r.= '<meta name="description" content="'.$description.'"'." />\n";
		if ($keywords)
			$r.= '<meta name="keywords" content="'.$keywords.'"'." />\n";
		if ($robots)
			$r.= '<meta name="robots" content="'.$robots.'"'." />\n";
		if ($refresh)
			$r.= '<meta http-equiv="refresh" content="'.$refresh.'"'." />\n";
		$css_on = false;
		foreach($inc_plugins as $item)
		{
			$func = $item.'_css';
			if (function_exists($func))
			{
				$css_on = true;
				break;
			}
		}
		if ($css_on === true)
		{
			if ($_SERVER['QUERY_STRING'])
				$qs = str_replace('&', '&amp;', $_SERVER['QUERY_STRING']).'&amp;inc='.INC.'&amp;as=css';
			else
				$qs = 'inc='.INC.'&amp;as=css';
			$r.= '<link rel="stylesheet" type="text/css" href="'.$inc.$inc_file.'.php?'.$qs.'"'." />\n";
		}
		else if ($css_file)
			$r.= '<link rel="stylesheet" type="text/css" href="'.$inc.$css_file.'"'." />\n";
		$js_on = false;
		foreach($inc_plugins as $item)
		{
			$func = $item.'_js';
			if (function_exists($func))
			{
				$js_on = true;
				break;
			}
		}
		if ($js_on === true)
		{
			if ($_SERVER['QUERY_STRING'])
				$qs = str_replace('&', '&amp;', $_SERVER['QUERY_STRING']).'&amp;inc='.INC.'&amp;as=js';
			else
				$qs = 'inc='.INC.'&amp;as=js';
			$r.= '<script type="text/javascript" src="'.$inc.$inc_file.'.php?'.$qs.'"></script>'."\n";
		}
		else if ($js_file)
			$r.= '<script type="text/javascript" src="'.$inc.$js_file.'"></script>'."\n";
		if ($custom_meta_tags)
			$r.= $custom_meta_tags."\n";
		if ($custom_head_tags2)
			$r.= $custom_head_tags2."\n";
		if ($body_attributes)
			$r.= '</head><body '.$body_attributes.">\n";
		else
			$r.= "</head><body>\n";
	}
	return $r.$p;
}

function inc_foot_text()
{
	global $inc_plugins, $html_on, $footer;
	$r = '';
	for ($i=count($inc_plugins)-1; $i>=0; $i--)
	{
		$item = $inc_plugins[$i];
		if ($GLOBALS[$item.'_on'] === true)
		{
			$func = $item.'_foot';
			if (function_exists($func))
				$r.= $func();
		}
	}
	if ($html_on === true)
		$r .= $footer;
	return $r;
}

function inc()
{
	global $xhtml, $html_on, $charset, $inc_plugins, $ob_on, $expires, $gzip,
	$inc_included, $inc_break;
	if ($inc_included)
	{
		if ($inc_break)
			exit;
		return;
	}
	foreach($inc_plugins as $item)
	{
		if ($GLOBALS[$item.'_on'] === true)
		{
			$func = $item.'_header';
			if (function_exists($func))
				$func();
		}
	}
	if ($html_on === true)
	{
		if ($charset)
			header('Content-Type: text/html; charset='.$charset);
	}
	if ($expires)
		inc_expires($expires);
	if ($gzip !== 0)
		inc_gzip($gzip);
	if ($ob_on === true)
		ob_start('inc_ob_callback');
	echo inc_text();
	$inc_included = true;
}

function inc_foot()
{
	global $ob_on, $inc_included;
	if ($inc_included)
		return;
	if ($ob_on !== true)
		echo inc_foot_text();
}

function inc_ob_callback($text)
{
	global $inc_plugins;
	$r = $text.inc_foot_text();
	foreach($inc_plugins as $item)
	{
		if ($GLOBALS[$item.'_on'] === true)
		{
			$func = $item.'_ob';
			if (function_exists($func))
				$r = $func($r);
		}
	}
	return $r;
}

function inc_add_to_query($name, $value, $url='')
{
	if (strlen($url) == 0)
	{
		$u[0] = $_SERVER['PHP_SELF'];
		$u[1] = (isset($_SERVER['QUERY_STRING'])) ? $_SERVER['QUERY_STRING'] : '';
	}
	else
		$u = explode('?', $url);
	if (strlen($u[1]) > 0)
	{
		$values = array();
		parse_str($u[1], $values);
		$values[$name] = $value;
		$u[1] = '';
		$count = 0;
		foreach($values as $k => $v)
		{
			if (strlen($v) > 0)
			{
				if ($count > 0)
					$u[1] .= '&';
				else
					$count++;
				$u[1].= $k.'='.urlencode($v);
			}
		}
	}
	else if (strlen($value) > 0)
		$u[1] = $name.'='.$value;
	if (strlen($u[1]) > 0)
		return $u[0].'?'.str_replace('&', '&amp;', $u[1]);
	else
		return $u[0];
}

?>
